{$APPTYPE CONSOLE}

uses SysUtils, Math;

var
  fin, fout, fans: TextFile;

procedure Ex(const msg: string; code: integer);
begin
  Write(msg);
  try
    CloseFile(fin); CloseFile(fout); CloseFile(fans);
  except
  end;
  Halt(code);
end;

procedure Move(var x, y: Integer; dir: Char);
begin
  case dir of
    'n': Dec(y);
    's': Inc(y);
    'w': Dec(x);
    'e': Inc(x);
    'z': ;
    else
      Ex('Unknown direction ' + dir, 2);
  end;
end;

var
  a, r, atturn: String;
  i, j, x, y, W, H, T, ya, N: Integer;
  ok: Boolean;
  xp, yp: array of Integer;
  p: array of String;
begin
  try
    AssignFile(fin, ParamStr(1)); Reset(fin);
  except on e: Exception do
    Ex('Error opening input: ' + e.Message, 3);
  end;
  try
    AssignFile(fans, ParamStr(3)); Reset(fans);
  except on e: Exception do
    Ex('Error opening answer: ' + e.Message, 3);
  end;
  try
    AssignFile(fout, ParamStr(2)); Reset(fout);
  except on e: Exception do
    Ex('Can''t open output: ' + e.Message, 2);
  end;
  if Eof(fout) then r := '' else Read(fout, r); //Ex('Output is empty', 2);

  Read(fin, W, H, T, ya, N);
  SetLength(xp, N);
  SetLength(yp, N);
  SetLength(p, N);
  for i := 0 to N - 1 do begin
    Read(fin, xp[i], yp[i], p[i]);
    p[i] := Trim(p[i]);
    Dec(xp[i]); Dec(yp[i]);
  end;

  //Read(fout, r);
  if r = 'IMPOSSIBLE' then begin
    Read(fans, a);
    if a = r then Ex('OK', 0) else Ex('incorrect IMPOSSIBLE', 1);
  end;
  if Length(r) > T then Ex('Answer too long', 1);

  x := 0;
  y := ya - 1;
  for j := 1 to Length(r) do begin
    atturn := ' at turn ' + IntToStr(j);
    for i := 0 to N - 1 do
      if (xp[i] = x) and (yp[i] = y) then
        Ex('Bumped into passenger ' + IntToStr(i + 1) + atturn, 1);
    if (x mod 2 = 1) then begin
      ok := false;
      for i := 0 to N - 1 do
        if (xp[i] = x) and (yp[i] < y) then begin
          ok := true;
          break;
        end;
      if not ok then Ex('Seen by camera v' + IntToStr(y + 1) + atturn, 1);
    end;
    if (y mod 2 = 1) then begin
      ok := false;
      for i := 0 to N - 1 do
        if (yp[i] = y) and (xp[i] < x) then begin
          ok := true;
          break;
        end;
      if not ok then Ex('Seen by camera h' + IntToStr(y + 1) + atturn, 1);
    end;
    for i := 0 to N - 1 do
      Move(xp[i], yp[i], p[i][j]);
    Move(x, y, r[j]);
    if (x < 0) or (x >= W) or (y < 0) or (y >= H) then
      Ex('Went out of borders' + atturn, 1);
  end;
  if (x <> W - 1) or (y <> ya - 1) then
    Ex('Did not reach the exit', 1);
  Read(fans, a);
  if a = 'IMPOSSIBLE' then Ex('impossible!', 3);
  Ex('OK', 0);
end.
